/*
 * C++ to IL compiler/generator math header
 * 
 * Copyright (C) 2010, 2011 Artur Kornacki
 *
 * This file is part of CAL++.
 *
 * CAL++ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CAL++ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CAL++.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __CAL_IL_MATH_H
#define __CAL_IL_MATH_H

#include <cal/cal_il.hpp>

#include <cal/il/math/cal_il_atanh.hpp>
#include <cal/il/math/cal_il_exp.hpp>
#include <cal/il/math/cal_il_floor.hpp>
#include <cal/il/math/cal_il_fract.hpp>
#include <cal/il/math/cal_il_frexp.hpp>
#include <cal/il/math/cal_il_ldexp.hpp>
#include <cal/il/math/cal_il_log.hpp>
#include <cal/il/math/cal_il_reciprocal.hpp>
#include <cal/il/math/cal_il_round.hpp>
#include <cal/il/math/cal_il_rsqrt.hpp>
#include <cal/il/math/cal_il_sqrt.hpp>
#include <cal/il/math/cal_il_tanh.hpp>

#endif
